## openscad 2014.03+dfsg

=== tests/CMakeLists.txt ===
# instructions - see ../doc/testing.txt

#set(DEBUG_OSCD 1) # print debug info during cmake

cmake_minimum_required(VERSION 2.8)
if("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}" VERSION_GREATER 2.8.3)
  # Explicitly use new include policy to avoid globally shadowing included modules
  # http://www.cmake.org/cmake/help/cmake-2-8-docs.html#policy:CMP0017
  cmake_policy(SET CMP0017 NEW)
endif()

# Needed for cmake < 2.8.3
include(CMakeParseArguments.cmake)

# Detect Lion and force gcc
IF (APPLE)
   EXECUTE_PROCESS(COMMAND sw_vers -productVersion OUTPUT_VARIABLE MACOSX_VERSION)
   IF (NOT ${MACOSX_VERSION} VERSION_LESS "10.9.0")
     message("Detected Maverick (10.9) or later")
     set(CMAKE_C_COMPILER "clang")
     set(CMAKE_CXX_COMPILER "clang++")
     # Somehow, since we build dependencies for 10.7, we need to also build executables
     # for 10.7. This used to not be necessary, but since 10.9 it apparently is..
     SET(CMAKE_OSX_DEPLOYMENT_TARGET 10.7 CACHE STRING "Deployment target")
   ELSEIF (NOT ${MACOSX_VERSION} VERSION_LESS "10.8.0")
     message("Detected Mountain Lion (10.8)")
     set(CMAKE_C_COMPILER "clang")
     set(CMAKE_CXX_COMPILER "clang++")
   ELSEIF (NOT ${MACOSX_VERSION} VERSION_LESS "10.7.0")
     message("Detected Lion (10.7)")
     set(CMAKE_C_COMPILER "clang")
     set(CMAKE_CXX_COMPILER "clang++")
   ELSE()
     message("Detected Snow Leopard (10.6) or older")
     if (USE_LLVM)
       message("Using LLVM compiler")
       set(CMAKE_C_COMPILER "llvm-gcc")
       set(CMAKE_CXX_COMPILER "llvm-g++")
     endif()
   ENDIF()
ENDIF(APPLE)


project(tests)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")

# Build debug build as default
if(NOT CMAKE_BUILD_TYPE)
  #  set(CMAKE_BUILD_TYPE Release)
  if(CMAKE_COMPILER_IS_GNUCXX)
    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    if (GCC_VERSION VERSION_GREATER 4.6)
      set(CMAKE_BUILD_TYPE RelWithDebInfo)
    else()
      set(CMAKE_BUILD_TYPE Debug)
    endif()
  else()
    set(CMAKE_BUILD_TYPE RelWithDebInfo)
  endif()
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")
endif()

if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG")
endif()

# MCAD
if(NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../libraries/MCAD/__init__.py)
  message(FATAL_ERROR "MCAD not found. You can install from the OpenSCAD root as follows: \n  git submodule update --init")
endif()

#
# Windows
#

if(WIN32 AND MSVC)
  set(WIN32_STATIC_BUILD "True")
endif()

if(WIN32_STATIC_BUILD AND MSVC)
  if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set(EMSG "\nTo build Win32 STATIC OpenSCAD please see doc/testing.txt")
    message(FATAL_ERROR ${EMSG})
  endif()
endif()

# Disable warnings
if(WIN32 AND MSVC)
  # too long decorated names
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4503")
  # int cast to bool in CGAL
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4800")
  # unreferenced parameters in CGAL
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4100")
  # fopen_s advertisement
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_CRT_SECURE_NO_DEPRECATE")
  # lexer uses strdup & other POSIX stuff
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_CRT_NONSTDC_NO_DEPRECATE")
  # M_PI
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_USE_MATH_DEFINES")
endif()

# Debugging - if you uncomment, use nmake -f Makefile > log.txt (the log is big)
if(WIN32 AND MSVC)
  # Linker debugging
  #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -VERBOSE")

  # Compiler debugging
  # you have to pass -DCMAKE_VERBOSE_MAKEFILE=ON to cmake when you run it. 
endif()

if(WIN32 AND CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -frounding-math")
endif()

# Clang compiler

if(${CMAKE_CXX_COMPILER} MATCHES ".*clang.*")
  # disable enormous amount of warnings about CGAL
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-c++11-extensions")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")
endif()

#
# Build test apps
#

function(inclusion user_set_path found_paths)
  # Set up compiler include paths with prepend/append rules. Input is 
  # a path and a set of paths. If user_set_path matches anything in found_paths
  # then we prepend the found_paths because we assume the user wants
  # their set_paths to be a priority. 

  if (DEBUG_OSCD)
    message(STATUS "inclusion ${user_set_path} ${found_paths}")
    message(STATUS "inclusion ${${user_set_path}} ${${found_paths}}")
  endif()
  set( inclusion_match 0 )
  foreach( found_path ${${found_paths}} )
    if (${found_path} MATCHES ${${user_set_path}}.*)
      set( inclusion_match 1 )
    endif()
  endforeach()
  if (user_set_path AND inclusion_match)
    include_directories(BEFORE ${${found_paths}})
    if (DEBUG_OSCD)
      message(STATUS "inclusion prepend ${${found_paths}} for ${user_set_path}")
    endif()
  else()
    include_directories(AFTER ${${found_paths}})
    if (DEBUG_OSCD)
      message(STATUS "inclusion append ${${found_paths}} for ${user_set_path}")
    endif()
  endif()
  set( inclusion_match 0 )
endfunction()

# Boost
# 
# FindBoost.cmake has been included from Cmake's GIT circa the end of 2011
# because most existing installs of cmake had a buggy older version. 
#
# Update this if FindBoost.cmake gets out of sync with the current boost release
# set(Boost_ADDITIONAL_VERSIONS "1.47.0" "1.46.0")

if (WIN32)
  set(Boost_USE_STATIC_LIBS TRUE)
  set(BOOST_STATIC TRUE)
  set(BOOST_THREAD_USE_LIB TRUE)
endif()

if (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(BOOST_ROOT "$ENV{OPENSCAD_LIBRARIES}")
  if (EXISTS ${BOOST_ROOT}/include/boost)
    # if boost is under OPENSCAD_LIBRARIES, then 
    # don't look in the system paths (workaround FindBoost.cmake bug)
    set(Boost_NO_SYSTEM_PATHS "TRUE")
    message(STATUS "BOOST_ROOT: " ${BOOST_ROOT})
  endif()
endif()

if (NOT $ENV{BOOSTDIR} STREQUAL "")
  set(BOOST_ROOT "$ENV{BOOSTDIR}")
  set(Boost_NO_SYSTEM_PATHS "TRUE")
  set(Boost_DEBUG TRUE)
  message(STATUS "BOOST_ROOT: " ${BOOST_ROOT})
endif()

find_package( Boost 1.35.0 COMPONENTS thread program_options filesystem system regex REQUIRED)
message(STATUS "Boost includes found: " ${Boost_INCLUDE_DIRS})
message(STATUS "Boost libraries found:")
foreach(boostlib ${Boost_LIBRARIES})
  message(STATUS "  " ${boostlib})
endforeach()

inclusion(BOOST_ROOT Boost_INCLUDE_DIRS)
add_definitions(-DBOOST_FILESYSTEM_VERSION=3) # Use V3 for boost 1.44-1.45

# Mac OS X
if(APPLE)
  FIND_LIBRARY(COCOA_LIBRARY Cocoa REQUIRED)
  FIND_LIBRARY(APP_SERVICES_LIBRARY ApplicationServices)
endif()


# Eigen

# Turn off Eigen SIMD optimization
if(NOT APPLE)
  if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "^FreeBSD")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DEIGEN_DONT_ALIGN")
  endif()
endif()

# Priority
# 3. EIGENDIR if set
# 1. OPENSCAD_LIBRARIES eigen3
# 4. system's standard include paths for eigen3

set(EIGEN_DIR "$ENV{EIGENDIR}")
set(OPENSCAD_LIBDIR "$ENV{OPENSCAD_LIBRARIES}")

if (EIGEN_DIR)
  set(EIGHINT ${EIGEN_DIR}/include/eigen3 ${EIGEN_DIR})
  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${EIGHINT})
endif()

if (NOT EIGEN_INCLUDE_DIR)
  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${OPENSCAD_LIBDIR}/include/eigen3)
endif()

if (NOT EIGEN_INCLUDE_DIR)
  if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/local/include/eigen3)
  elseif (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/pkg/include/eigen3)
  elseif (APPLE)
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /opt/local/include/eigen3)
  else()
    find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/include/eigen3)
  endif()
endif()

if (NOT EIGEN_INCLUDE_DIR)
  message(STATUS "Eigen not found")
else()
  message(STATUS "Eigen found in " ${EIGEN_INCLUDE_DIR})
  inclusion(EIGEN_DIR EIGEN_INCLUDE_DIR)
endif()

# OpenGL
find_package(OpenGL REQUIRED)
if (NOT OPENGL_GLU_FOUND)
  message(STATUS "GLU not found in system paths...searching $ENV{OPENSCAD_LIBRARIES} ")
  find_library(OPENGL_glu_LIBRARY GLU HINTS $ENV{OPENSCAD_LIBRARIES}/lib)
  if (NOT OPENGL_glu_LIBRARY)
    message(FATAL "GLU library not found")
  endif()
  set(OPENGL_LIBRARIES ${OPENGL_glu_LIBRARY} ${OPENGL_LIBRARIES})
  message(STATUS "OpenGL LIBRARIES: ")
  foreach(GLLIB ${OPENGL_LIBRARIES})
    message(STATUS "  " ${GLLIB})
  endforeach()
endif()

# OpenCSG
if (NOT $ENV{OPENCSGDIR} STREQUAL "")
  set(OPENCSG_DIR "$ENV{OPENCSGDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(OPENCSG_DIR "$ENV{OPENSCAD_LIBRARIES}")
endif()
if (NOT OPENCSG_INCLUDE_DIR)
  message(STATUS "OPENCSG_DIR: " ${OPENCSG_DIR})
  find_path(OPENCSG_INCLUDE_DIR
            opencsg.h
            HINTS ${OPENCSG_DIR}/include)
  find_library(OPENCSG_LIBRARY
               opencsg
               HINTS ${OPENCSG_DIR}/lib)
  if (NOT OPENCSG_INCLUDE_DIR OR NOT OPENCSG_LIBRARY)
    message(FATAL_ERROR "OpenCSG not found")
  else()
    message(STATUS "OpenCSG include found in " ${OPENCSG_INCLUDE_DIR})
    message(STATUS "OpenCSG library found in " ${OPENCSG_LIBRARY})
  endif()
endif()
inclusion(OPENCSG_DIR OPENCSG_INCLUDE_DIR)

# GLEW

if(WIN32_STATIC_BUILD)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DGLEW_STATIC")
endif()

if (NOT $ENV{GLEWDIR} STREQUAL "")
  set(GLEW_DIR "$ENV{GLEWDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(GLEW_DIR "$ENV{OPENSCAD_LIBRARIES}")
endif()
if (GLEW_DIR)
  find_path(GLEW_INCLUDE_DIR
            GL/glew.h
            HINTS ${GLEW_DIR}/include
	    NO_DEFAULT_PATH)
  find_library(GLEW_LIBRARY
               NAMES GLEW glew
               HINTS ${GLEW_DIR}/lib ${GLEW_DIR}/lib64
	       NO_DEFAULT_PATH)
  if (GLEW_INCLUDE_DIR AND GLEW_LIBRARY)
    set(GLEW_FOUND 1)
  endif()
endif()

if (NOT GLEW_FOUND)
  find_package(GLEW REQUIRED)
endif()

message(STATUS "GLEW include: " ${GLEW_INCLUDE_DIR})
message(STATUS "GLEW library: " ${GLEW_LIBRARY})

inclusion(GLEW_DIR GLEW_INCLUDE_DIR)

# Flex/Bison
find_package(BISON REQUIRED)

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  # FreeBSD has an old flex in /usr/bin and a new flex in /usr/local/bin
  set(FLEX_EXECUTABLE /usr/local/bin/flex)
endif()

# prepend the dir where deps were built
if (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  set(OSCAD_DEPS "")
  set(OSCAD_DEPS_PATHS $ENV{OPENSCAD_LIBRARIES}/include)
  inclusion(OSCAD_DEPS OSCAD_DEPS_PATHS)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
  include_directories( /usr/pkg/include /usr/X11R7/include )
  set(FLEX_EXECUTABLE /usr/pkg/bin/flex)
  if(NOT ${CMAKE_CXX_COMPILER} MATCHES ".*clang.*")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif()
endif()

find_package(FLEX REQUIRED)
# The COMPILE_FLAGS and forced C++ compiler is just to be compatible with qmake
if (WIN32)
  set(FLEX_UNISTD_FLAG "-DYY_NO_UNISTD_H")
endif()
FLEX_TARGET(OpenSCADlexer ../src/lexer.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.cpp COMPILE_FLAGS "-Plexer ${FLEX_UNISTD_FLAG}")
BISON_TARGET(OpenSCADparser ../src/parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c COMPILE_FLAGS "-p parser")
ADD_FLEX_BISON_DEPENDENCY(OpenSCADlexer OpenSCADparser)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c PROPERTIES LANGUAGE "CXX")

# CGAL

if (NOT $ENV{CGALDIR} STREQUAL "")
  set(CGAL_DIR "$ENV{CGALDIR}")
elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
  if (EXISTS "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
    set(CMAKE_MODULE_PATH "${CGAL_DIR}" ${CMAKE_MODULE_PATH})
  elseif (EXISTS "$ENV{OPENSCAD_LIBRARIES}/include/CGAL")
    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}")
    set(CMAKE_MODULE_PATH "${CGAL_DIR}" ${CMAKE_MODULE_PATH})
  endif()
endif()
message(STATUS "CGAL_DIR: " ${CGAL_DIR})
find_package(CGAL REQUIRED)

=== debian/changelog ===
openscad (2014.03+dfsg-1) unstable; urgency=low

  * New upstream version
    - resize module
    - scale parameter on linear_extrude
    - recursive use of modules
    - assignments can depend on previous assignments
    - syntax highlighting
    - user library path
    - support for opening dxf files
    - new behavior of preview and highlight operators
    - new diameter arguments
    - parent_module() and children() functions
    - Unicode handling
    - negative steps in ranges
    - norm() and cross() functions
    - new command line options
    - bugfixes
    - drops many test programs which caused issues when ran outside the build
      directory
  * Copyright file updates
  * Build-depend on glib
  * Build-conflict against libgles2-dev (eg libgles2-mesa-dev)
  * Patches dropped due to upstream inclusion:
    - changes to eigen.pri
  * Patch out verbose mode through qmake
  * Patch tests/CTestCustom.template to use test_pretty_print.py instead of
    the test_pretty_print.c wrapper that is just used to transport a hardcoded
    path that is not present on installed systems anyway
  * Patch tests/test_pretty_print.py to use Debian package information instead
    of unavailable git information
  * Drop scripts directory for +dfsg repackaging
  * Explicitly set OpenSCAD version from upstream version
  * Patch tests/test_cmdline_tool.py to use absolute paths (because openscad
    and echotest have different behaviors in that respect)
  * Add build dependencies to run the test suite at build time
  * Depend on openscad-mcad for building to run the test suite
    - Patch out check for MCAD subtree
  * Change Standards-Version to 3.9.5 (no further changes)

 -- Christian M. Amsüss <chrysn@fsfe.org>  Mon, 10 Mar 2014 20:08:15 +0100

=== debian/control ===
Source: openscad
Priority: optional
Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
# while it is common to have libgl1-mesa-dev as the default option for
# libgl1-dev, libgl1-mesa-swx11-dev is chosen here to avoid that an installer
# for a build server gets the idea of installing xserver-xorg-core; also, this
# is why the sequence of xserver-xorg-core and xvfb is flipped here relative to
# openscad-testing, where they come from.
Build-Depends:
    debhelper (>= 9),
    qt4-qmake (>=4.4),
    libcgal-dev (>=3.6),
    libopencsg-dev (>=1.3.0),
    libeigen3-dev,
    libglib2.0-dev,
    bison (>= 2.4),
    flex (>=2.5.35),
    libqt4-opengl-dev,
    libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
    libgmp-dev | libgmp10-dev | libgmp3-dev,
    libmpfr-dev,
    python,
    cmake,
    libboost-dev (>= 1.46.0),
    libboost-regex-dev,
    libboost-system-dev,
    libboost-filesystem-dev,
    chrpath,
    pkg-config,
    imagemagick,
    libgl1-mesa-swx11-dev | libgl-dev,
    xvfb | xserver-xorg-core,
    libgl1-mesa-swx11 | xserver-xorg-core,
    openscad-mcad
# openscad is not gles compatible yet. this line makes builds abort before they
# faile at compile time. libqt4-opengl-dev currently pulls libgles2-mesa-dev in
# on ubuntu arm{el,hf}.
Build-Conflicts:
    libgles2-dev
Standards-Version: 3.9.5
Section: graphics
Homepage: http://openscad.org/
Vcs-Browser: http://gitorious.org/openscad-debian/openscad/commits/debian
Vcs-Git: git://gitorious.org/openscad-debian/openscad.git/ -b debian

Package: openscad
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Recommends:
    openscad-mcad
Suggests:
    meshlab,
    geomview,
    librecad,
    openscad-testing
Description: script file based graphical CAD environment
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 OpenSCAD is not an interactive modeller. Instead it is something like a
 3D-compiler that reads in a script file that describes the object and renders
 the 3D model from this script. This gives the designer full control over the
 modelling process and enables him to easily change any step in the modelling
 process or make designes that are defined by configurable parameters.

Package: openscad-testing
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    openscad,
    openscad-testing-data,
    python,
    python-argparse,
    cmake,
    imagemagick,
    xserver-xorg-core | xvfb,
    xserver-xorg-core | libgl1-mesa-swx11
Description: script file based graphical CAD environment (test suite)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains all programs required to run the test suites.

Package: openscad-testing-data
Architecture: all
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    openscad-mcad
# the examples, which are shipped in openscad, are part of the test suite
Recommends: openscad
Suggests: openscad-testing
Description: script file based graphical CAD environment (test suite data)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains the data required to run the test suites.

Package: openscad-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    openscad (=${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Description: script file based graphical CAD environment (debugging symbols)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains debugging information stripped from the binaries.

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg$// \
    http://files.openscad.org/openscad-([0-9.]*).src.tar.gz \
    debian sh debian/repack.stub

## openscad 2015.03

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,7 @@
     set(CMAKE_BUILD_TYPE RelWithDebInfo)
   endif()
 endif()
+message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
 
 if(CMAKE_COMPILER_IS_GNUCXX)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")
@@ -66,11 +67,33 @@
 
 if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG")
+else()
+  # asserts will be compiled out with NDEBUG -- must remove it
+  foreach (flags_var_to_scrub
+           CMAKE_CXX_FLAGS_RELEASE
+           CMAKE_CXX_FLAGS_RELWITHDEBINFO
+           CMAKE_CXX_FLAGS_MINSIZEREL
+           CMAKE_C_FLAGS_RELEASE
+           CMAKE_C_FLAGS_RELWITHDEBINFO
+           CMAKE_C_FLAGS_MINSIZEREL)
+    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" " "
+           "${flags_var_to_scrub}" "${${flags_var_to_scrub}}")
+  endforeach()
 endif()
 
 # MCAD
 if(NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../libraries/MCAD/__init__.py)
   message(FATAL_ERROR "MCAD not found. You can install from the OpenSCAD root as follows: \n  git submodule update --init")
+endif()
+
+# NULLGL - Allow us to build without OpenGL(TM). run 'cmake .. -DNULLGL=1'
+# Most tests will fail, but it can be used for testing/experiments
+
+if(NULLGL)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNULLGL")
+  set(SKIP_IMAGEMAGICK "1") # we dont generate png, so nothing to compare
+else()
+  set(ENABLE_OPENCSG_FLAG "-DENABLE_OPENCSG")
 endif()
 
 #
@@ -113,8 +136,10 @@
   # you have to pass -DCMAKE_VERBOSE_MAKEFILE=ON to cmake when you run it. 
 endif()
 
-if(WIN32 AND CMAKE_COMPILER_IS_GNUCXX)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -frounding-math")
+if(CMAKE_COMPILER_IS_GNUCXX)
+  if (WIN32 OR ${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -frounding-math")
+  endif()
 endif()
 
 # Clang compiler
@@ -124,7 +149,6 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-c++11-extensions")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")
 endif()
 
@@ -139,27 +163,34 @@
   # their set_paths to be a priority. 
 
   if (DEBUG_OSCD)
-    message(STATUS "inclusion ${user_set_path} ${found_paths}")
-    message(STATUS "inclusion ${${user_set_path}} ${${found_paths}}")
-  endif()
-  set( inclusion_match 0 )
-  foreach( found_path ${${found_paths}} )
-    if (${found_path} MATCHES ${${user_set_path}}.*)
-      set( inclusion_match 1 )
+    message(STATUS "inclusion:")
+    message(STATUS "  ${user_set_path}: ${${user_set_path}}")
+    message(STATUS "  ${found_paths}: ${${found_paths}}")
+  endif()
+  set(inclusion_match 0)
+  if (${user_set_path})
+    foreach(found_path ${${found_paths}})
+      string(FIND ${found_path} ${${user_set_path}} INDEX)
+      if (DEFINED INDEX)
+        if (${INDEX} EQUAL 0)
+          set(inclusion_match 1)
+        endif()
+      endif()
+    endforeach()
+    if (inclusion_match)
+      include_directories(BEFORE ${${found_paths}})
+      if (DEBUG_OSCD)
+        message(STATUS "inclusion prepend ${${found_paths}} for ${user_set_path}")
+      endif()
+      set(inclusion_match 0)
     endif()
-  endforeach()
-  if (user_set_path AND inclusion_match)
-    include_directories(BEFORE ${${found_paths}})
-    if (DEBUG_OSCD)
-      message(STATUS "inclusion prepend ${${found_paths}} for ${user_set_path}")
-    endif()
-  else()
+  endif()
+  if (NOT inclusion_match)
     include_directories(AFTER ${${found_paths}})
     if (DEBUG_OSCD)
       message(STATUS "inclusion append ${${found_paths}} for ${user_set_path}")
     endif()
   endif()
-  set( inclusion_match 0 )
 endfunction()
 
 # Boost
@@ -194,14 +225,26 @@
 endif()
 
 find_package( Boost 1.35.0 COMPONENTS thread program_options filesystem system regex REQUIRED)
-message(STATUS "Boost includes found: " ${Boost_INCLUDE_DIRS})
+message(STATUS "Boost ${Boost_VERSION} includes found: " ${Boost_INCLUDE_DIRS})
 message(STATUS "Boost libraries found:")
 foreach(boostlib ${Boost_LIBRARIES})
   message(STATUS "  " ${boostlib})
 endforeach()
 
 inclusion(BOOST_ROOT Boost_INCLUDE_DIRS)
-add_definitions(-DBOOST_FILESYSTEM_VERSION=3) # Use V3 for boost 1.44-1.45
+if (${Boost_VERSION} LESS 104600)
+  add_definitions(-DBOOST_FILESYSTEM_VERSION=3) # Use V3 for boost 1.44-1.45
+endif()
+
+# On Mac, we need to link against the correct C++ library. We choose the same one
+# as Boost uses.
+if(APPLE)
+  execute_process(COMMAND grep -q __112basic_string ${Boost_LIBRARIES}
+                  RESULT_VARIABLE BOOST_USE_STDLIBCPP)
+  if (NOT BOOST_USE_STDLIBCPP)
+     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
+  endif()
+endif()
 
 # Mac OS X
 if(APPLE)
@@ -233,11 +276,13 @@
 endif()
 
 if (NOT EIGEN_INCLUDE_DIR)
-  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${OPENSCAD_LIBDIR}/include/eigen3)
+  # The NO_CMAKE_SYSTEM_PATH is necessary to avoid OS X from picking up 
+  # a stray Eigen from /Library/Framework
+  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${OPENSCAD_LIBDIR}/include/eigen3 NO_CMAKE_SYSTEM_PATH)
 endif()
 
 if (NOT EIGEN_INCLUDE_DIR)
-  if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
+  if (${CMAKE_SYSTEM_NAME} MATCHES "^FreeBSD")
     find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/local/include/eigen3)
   elseif (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
     find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/pkg/include/eigen3)
@@ -254,6 +299,10 @@
   message(STATUS "Eigen found in " ${EIGEN_INCLUDE_DIR})
   inclusion(EIGEN_DIR EIGEN_INCLUDE_DIR)
 endif()
+
+###### NULLGL wraps all OpenGL(TM) items (GL, Glew, OpenCSG)
+###### Several pages of code fall under this 'if( NOT NULLGL )'
+if (NOT NULLGL)
 
 # OpenGL
 find_package(OpenGL REQUIRED)
@@ -327,51 +376,8 @@
 
 inclusion(GLEW_DIR GLEW_INCLUDE_DIR)
 
+endif() ########## NULLGL ENDIF
+
 # Flex/Bison
 find_package(BISON REQUIRED)
 
-if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
-  # FreeBSD has an old flex in /usr/bin and a new flex in /usr/local/bin
-  set(FLEX_EXECUTABLE /usr/local/bin/flex)
-endif()
-
-# prepend the dir where deps were built
-if (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
-  set(OSCAD_DEPS "")
-  set(OSCAD_DEPS_PATHS $ENV{OPENSCAD_LIBRARIES}/include)
-  inclusion(OSCAD_DEPS OSCAD_DEPS_PATHS)
-endif()
-
-if(${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
-  include_directories( /usr/pkg/include /usr/X11R7/include )
-  set(FLEX_EXECUTABLE /usr/pkg/bin/flex)
-  if(NOT ${CMAKE_CXX_COMPILER} MATCHES ".*clang.*")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
-  endif()
-endif()
-
-find_package(FLEX REQUIRED)
-# The COMPILE_FLAGS and forced C++ compiler is just to be compatible with qmake
-if (WIN32)
-  set(FLEX_UNISTD_FLAG "-DYY_NO_UNISTD_H")
-endif()
-FLEX_TARGET(OpenSCADlexer ../src/lexer.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.cpp COMPILE_FLAGS "-Plexer ${FLEX_UNISTD_FLAG}")
-BISON_TARGET(OpenSCADparser ../src/parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c COMPILE_FLAGS "-p parser")
-ADD_FLEX_BISON_DEPENDENCY(OpenSCADlexer OpenSCADparser)
-set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c PROPERTIES LANGUAGE "CXX")
-
-# CGAL
-
-if (NOT $ENV{CGALDIR} STREQUAL "")
-  set(CGAL_DIR "$ENV{CGALDIR}")
-elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
-  if (EXISTS "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
-    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
-    set(CMAKE_MODULE_PATH "${CGAL_DIR}" ${CMAKE_MODULE_PATH})
-  elseif (EXISTS "$ENV{OPENSCAD_LIBRARIES}/include/CGAL")
-    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}")
-    set(CMAKE_MODULE_PATH "${CGAL_DIR}" ${CMAKE_MODULE_PATH})
-  endif()
-endif()
-message(STATUS "CGAL_DIR: " ${CGAL_DIR})
-find_package(CGAL REQUIRED)

=== scripts/examples-html/Makefile ===
EXAMPLES := ../../examples
SRC=$(wildcard $(EXAMPLES)/*/*.scad)
PNG=$(patsubst $(EXAMPLES)/%.scad,html/%.png,$(SRC))
HTML=$(patsubst $(EXAMPLES)/%.scad,html/%.html,$(SRC))

OPENSCAD := ../../OpenSCAD.app/Contents/MacOS/OpenSCAD
#OPENSCAD := openscad
ARGS := --imgsize=1200,900 --camera=0,0,0,55,0,25,180 --viewall --autocenter

all : $(PNG) $(HTML) example-data.js assets

.PHONY: clean
clean :
	rm -rf html

.PHONY: assets
assets :
	cp -a assets html/

.PHONY: example-data.js
example-data.js :
	( \
	echo "openscad_examples = ["; \
	for a in Basics Functions Shapes Extrusion Advanced; \
	do \
		echo "  {"; \
		echo "    name : \"$$a\","; \
		echo "    files : ["; \
		for f in "$(EXAMPLES)/$$a/"*.scad ; \
		do \
			echo "      \"`basename -s .scad $$f`\","; \
		done; \
		echo "    ]"; \
		echo "  },"; \
	done; \
	echo "];" \
	) > html/example-data.js

html/%.png : $(EXAMPLES)/%.scad
	mkdir -p `dirname $@`
	$(OPENSCAD) $(ARGS) -o $@ $< > out.log 2>&1

html/%.html : $(EXAMPLES)/%.scad template-pre.html template-post.html
	#echo $(notdir $(patsubst %.scad,%.png,$<))
	mkdir -p `dirname $@`
	sed -e 's/@@IMAGE@@/$(notdir $(patsubst %.scad,%.png,$<))/g' template-pre.html > $@
	sed -e 's/</\&lt/; s/>/\&gt/;' $< >> $@
	cat template-post.html >> $@

## openscad 2015.03-1+dfsg

=== debian/changelog ===
openscad (2015.03-1+dfsg-3) unstable; urgency=medium

  * Use libgl1-mesa-dri instead of the abandoned libgl1-mesa-swx11 (Closes:
    #803248)
  * Build-depend on libcgal-qt5-dev (see #804539)
  * Add lintian override against source-is-missing (see #798900)
  * Change repository URIs to collab-maint
  * Add a note about the build logs to README.source

 -- Christian M. Amsüss <chrysn@fsfe.org>  Mon, 09 Nov 2015 14:00:17 +0100

openscad (2015.03-1+dfsg-2) unstable; urgency=medium

  * Output the tests' HTML rendering to the build log on failure
  * Go back to being lax about regression tests (See #795300)

 -- Christian M. Amsüss <chrysn@fsfe.org>  Fri, 14 Aug 2015 14:46:19 +0200

openscad (2015.03-1+dfsg-1) unstable; urgency=medium

  [ Chow Loong Jin ]

  * New upstream version
    + Language Features
      - Added text() module for 2D text
      - Added offset() module for 2D offsets
      - Added list comprehensions and let()
      - Added concat() function
      - Added chr() function
      - surface() can now take PNG images as input
      - min() and max() can now take a vector argument
      - 2D minkowski can now handle polygons with holes
      - Variables can now be assigned in local blocks without using assign()
    + Program Features
      - Added Toolbar icons
      - New code editor based on QScintilla
      - Added Splash screen
      - Added SVG export
      - Added AMF export
      - Added --viewall and --autocenter cmd-line parameters
      - GUI is now translated into German, Czech, Spanish, French and Russian
      - MDI (Multiple Document Interface) is now available on all platforms
      - Color schemes for viewer and editor can be user-edited using JSON files
      - GUI components are now dockable
      - Added Tickmarks on axes
    + Bugfixes/improvements
      - Performance improvement: 2D (clipper), preview, hull, minkowski, surface
      - Performance improvement: Reduce duplicate evaluation of identical
        expressions
      - Better recursion behavior
      - STL export and import is now more robust
      - Internal cavities are better supported
      - New examples
      - Windows cmd-line behaves better
      - Better mirror() and scale() behavior when using negative factors
      - Fixes a segfault bug (Closes: #787127)
      - Removes __DATE__ reference (Closes: #781638)
    + Deprecations
      - polyhedron() now takes a faces= argument rather than triangles=
      - assign() is no longer needed. Local variables can be created in any
        scope
  * Use qt5
  * Bump Standards-Version to 3.9.6
  * Fix up watch file options
  * Update what goes in the +dfsg package
    - Remove src/SparkleAutoUpdater.* from dfsg branch
  * Update +dfsg branch mechanisms to uscan
  * Update debian/copyright
  * Set uversionmangle in debian/watch for microreleases
  * New patches
    * Build system: Work around missing -lX11
    * Add hashbang to test_cmdline_tool.py

  [ Christian M. Amsüss ]

  * Switch source to using gbp pq
  * Depend on versioned imagemagick to avoid issues with graphicsmagick
  * Updated patches
  * New patches
    * Run tests with the shipped OpenSCAD binary
    * Minor spelling and syntax fixes
  * Don't build programs used neither in shipping nor for tests
  * Use debhelper's cmake / ctest targets
  * Drop chrpath tricks
  * Drop installation of build test results
  * Add README for test suite
  * Unconditionally render build time tests in virtual frame buffer
  * Exclude the tests known to fail from building, require the rest to work
  * Install EMACS mode (Closes: #789318)
  * Add DEP-3 tags to patches
  * Fix building with DEB_BUILD_OPTIONS=nocheck
  * Ship the provided font files in the test data
    - Override lintian's warnings against it

 -- Christian M. Amsüss <chrysn@fsfe.org>  Tue, 11 Aug 2015 18:15:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,22 @@
 Source: openscad
 Priority: optional
 Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
-# while it is common to have libgl1-mesa-dev as the default option for
-# libgl1-dev, libgl1-mesa-swx11-dev is chosen here to avoid that an installer
-# for a build server gets the idea of installing xserver-xorg-core; also, this
-# is why the sequence of xserver-xorg-core and xvfb is flipped here relative to
-# openscad-testing, where they come from.
+# libcgal-qt5-dev is a workaround for http://bugs.debian.org/804539
 Build-Depends:
     debhelper (>= 9),
-    qt4-qmake (>=4.4),
+    qt5-qmake,
+    libcgal-qt5-dev,
     libcgal-dev (>=3.6),
     libopencsg-dev (>=1.3.0),
+    libqt5scintilla2-dev,
+    libfreetype6-dev,
+    libfontconfig1-dev,
+    libharfbuzz-dev,
     libeigen3-dev,
     libglib2.0-dev,
     bison (>= 2.4),
     flex (>=2.5.35),
-    libqt4-opengl-dev,
+    libqt5opengl5-dev,
     libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
     libgmp-dev | libgmp10-dev | libgmp3-dev,
     libmpfr-dev,
@@ -25,23 +26,24 @@
     libboost-regex-dev,
     libboost-system-dev,
     libboost-filesystem-dev,
-    chrpath,
     pkg-config,
-    imagemagick,
-    libgl1-mesa-swx11-dev | libgl-dev,
-    xvfb | xserver-xorg-core,
-    libgl1-mesa-swx11 | xserver-xorg-core,
-    openscad-mcad
+    imagemagick (>= 6.5.9.3),
+    libgl1-mesa-dri,
+    xvfb,
+    libgl1-mesa-dev,
+    openscad-mcad,
+    ttf-marvosym,
+    fonts-hosny-amiri
 # openscad is not gles compatible yet. this line makes builds abort before they
 # faile at compile time. libqt4-opengl-dev currently pulls libgles2-mesa-dev in
 # on ubuntu arm{el,hf}.
 Build-Conflicts:
     libgles2-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Section: graphics
 Homepage: http://openscad.org/
-Vcs-Browser: http://gitorious.org/openscad-debian/openscad/commits/debian
-Vcs-Git: git://gitorious.org/openscad-debian/openscad.git/ -b debian
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/openscad.git/
+Vcs-git: git://anonscm.debian.org/collab-maint/openscad.git -b debian
 
 Package: openscad
 Architecture: any
@@ -67,6 +69,7 @@
 
 Package: openscad-testing
 Architecture: any
+# the versioned imagemagick dependency stems from https://github.com/openscad/openscad/issues/1360
 Depends:
     ${shlibs:Depends},
     ${misc:Depends},
@@ -75,9 +78,9 @@
     python,
     python-argparse,
     cmake,
-    imagemagick,
+    imagemagick (>= 6.5.9.3),
     xserver-xorg-core | xvfb,
-    xserver-xorg-core | libgl1-mesa-swx11
+    libgl1-mesa-dri
 Description: script file based graphical CAD environment (test suite)
  OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
  aspects rather than artistic ones.
@@ -89,7 +92,9 @@
 Depends:
     ${shlibs:Depends},
     ${misc:Depends},
-    openscad-mcad
+    openscad-mcad,
+    ttf-marvosym,
+    fonts-hosny-amiri
 # the examples, which are shipped in openscad, are part of the test suite
 Recommends: openscad
 Suggests: openscad-testing

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
UPSTREAMVERS = $(shell dpkg-parsechangelog | sed -n 's/^Version: \([^+~]*\).*$$/\1/p')

export QT_SELECT = qt5

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- VERSION=$(UPSTREAMVERS)

override_dh_auto_build:
	dh_auto_build

	# not run in dh_auto_configure stage, as it requires the openscad binary to be already built
	dh_auto_configure -Dtests

	# is cgalcachetest only required in out-of-tree builds?
	dh_auto_build -Dtests -Scmake -- csgtexttest cgalcachetest

	# fix absolute paths in ctest scripts (relative paths will work during
	# the build time tests, and are catered for by the openscad-testrun
	# script).
	#
	# note that often, a `../openscad` reference remains. this is left in
	# place, as not all tools involved honor $PATH (eg. because they do an
	# explicit `os.path.exists` on their openscad binary).
	cd obj-* && perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s/\Q$$here\E/./g' *.cmake
	perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s/\Q$$here\/tests\E/./g' obj-*/*.cmake

override_dh_auto_test:
	# workaround to have the test suite usable out-of-tree. FIXME introduce
	# a fix for upstream that makes ctest also work with out-of-tree
	# building.
	cd obj-* && ln -s ../tests/* -t. || echo "Some files are expected to already be present."

	# OPENSCADPATH has to be set because the default library dir is
	# determined based on the openscad binary's path (will be ok after
	# installation).
	#
	# clearing DISPLAY is not strictly necessary here as this is already
	# done by the build environment (at least by gbp buildpackage), but it
	# makes it clear that the intent is to always render the build-time
	# tests in software.
	#
	# as for the tests excluded with --exclude-regex, see README.testsuite.
	DISPLAY= OPENSCADPATH=/usr/share/openscad/libraries dh_auto_test -Dtests -Scmake -- ARGS+="--exclude-regex issue1165\\|issue1215\\|throwntogethertest_issue1089\\|openscad-cameyeortho_camera-tests\\|openscad-cameyeortho-viewall_camera-tests" || ( echo '---- content of ' obj-*/Testing/Temporary/*_report.html ' ----'; cat obj-*/Testing/Temporary/*_report.html; echo; echo '---- end content ----'; exit 0)

override_dh_auto_install:
	# fix absolute paths in generated scad files. this step logically
	# belongs to the similar lines in the dh_auto_build override, but can
	# first be done here becaus for the build time tests, the original
	# paths are still required.
	find testdata -name \*.scad  -exec perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s[\Q$$here\E/tests/../testdata][/usr/share/openscad/testdata]g' {} +

	dh_auto_install --destdir=debian/openscad

	# don't ship mcad, neither the empty directory (when this is built from
	# a normal git source checkout) nor the full library (when this is
	# built from a git checkout with submodules or from a tarball). mcad
	# gets its own package.
	rm -rf debian/openscad/usr/share/openscad/libraries

	# remove fonts
	rm -rf debian/openscad/usr/share/openscad/fonts

override_dh_install:
	dh_install -Xtestdata/ttf/liberation-2.00.1/LICENSE

override_dh_strip:
	dh_strip --dbg-package openscad-dbg

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg \
    http://files.openscad.org/openscad-([0-9.-]*).src.tar.gz

## openscad 2015.03-2%2Bdfsg

=== debian/changelog ===
openscad (2015.03-2+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * Add patch for translation generation (Closes: #844881)
  * Bump standards version (no changes needed)
  * Use debhelper 10
  * Drop obsolete lintian overrides
  * Implement a proper clean debian/rules target

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sun, 27 Nov 2016 17:37:27 +0100

openscad (2015.03-2+dfsg-1) experimental; urgency=medium

  [ upstream ]

  * New bugfix release

  [ Christian M. Amsüss ]

  * Fix Build-Conflicts against GLES
  * Pick and enable new OpenGL widget from upstream (Closes: #806670)
  * Drop patches applied upstream, refresh and simplify others
  * Drop debug-mode workaround (now handled by debhelper for qmake)
  * Update copyright file
  * Notes on forwarded patches

 -- Christian M. Amsüss <chrysn@fsfe.org>  Fri, 08 Jan 2016 11:46:03 +0100

=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,10 @@
 export QT_SELECT = qt5
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- VERSION=$(UPSTREAMVERS)
+	dh_auto_configure -- VERSION=$(UPSTREAMVERS) CONFIG-=debug CONFIG+=qopenglwidget
 
 override_dh_auto_build:
 	dh_auto_build
@@ -73,3 +73,8 @@
 
 override_dh_strip:
 	dh_strip --dbg-package openscad-dbg
+
+override_dh_auto_clean:
+	dh_auto_clean
+
+	dh_auto_clean -Dtests -Scmake

## openscad 2015.03-2+dfsg

=== debian/changelog ===
openscad (2015.03-2+dfsg-2ubuntu1) zesty; urgency=medium

  * Revert the Build-Conflicts change; on Ubuntu qtbase5-dev Depends on
    libgles2-dev.

 -- Iain Lane <iain@orangesquash.org.uk>  Mon, 28 Nov 2016 14:01:58 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: openscad
 Priority: optional
-Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
 # libcgal-qt5-dev is a workaround for http://bugs.debian.org/804539
 Build-Depends:
-    debhelper (>= 9),
+    debhelper (>= 10),
     qt5-qmake,
+    qtbase5-dev (>= 5.4),
     libcgal-qt5-dev,
     libcgal-dev (>=3.6),
     libopencsg-dev (>=1.3.0),
@@ -16,6 +18,7 @@
     libglib2.0-dev,
     bison (>= 2.4),
     flex (>=2.5.35),
+# workaround for https://github.com/openscad/openscad/issues/1543
     libqt5opengl5-dev,
     libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
     libgmp-dev | libgmp10-dev | libgmp3-dev,
@@ -35,11 +38,13 @@
     ttf-marvosym,
     fonts-hosny-amiri
 # openscad is not gles compatible yet. this line makes builds abort before they
-# faile at compile time. libqt4-opengl-dev currently pulls libgles2-mesa-dev in
-# on ubuntu arm{el,hf}.
+# faile at compile time. libqt5opengl5 uses gles on arm{el,hf}, making openscad
+# currently unbuildable there. tracked upstream as
+# https://github.com/openscad/openscad/issues/292 and in debian as
+# http://bugs.debian.org/797816
 Build-Conflicts:
     libgles2-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: graphics
 Homepage: http://openscad.org/
 Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/openscad.git/
